# generated by datamodel-codegen:
#   filename:  data_room_action_response.json

from __future__ import annotations

from enum import Enum
from typing import Any, Mapping, Optional, Sequence, Union

from pydantic import BaseModel, ConfigDict, Field, RootModel, conint


class Kind(Enum):
    media = 'media'


class DataRoomActionResponse1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    provisionBaseAudiencePolicyIds: Mapping[str, Any]


class DataRoomActionResponse2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deprovisionBaseAudiencePolicyIds: Mapping[str, Any]


class DataRoomActionResponse3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    provisionSeedAudiencePolicyIds: Mapping[str, Any]


class DataRoomActionResponse4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deprovisionSeedAudiencePolicyIds: Mapping[str, Any]


class DeleteCustomAudience(BaseModel):
    numDeletedAudiences: conint(ge=0)


class DataRoomActionResponse6(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deleteCustomAudience: DeleteCustomAudience


class Kind46(Enum):
    BASE = 'BASE'


class AudienceReference13(BaseModel):
    kind: Kind46


class Kind47(Enum):
    CUSTOM = 'CUSTOM'


class AudienceReference14(BaseModel):
    id: str
    kind: Kind47


class Kind48(Enum):
    SEED = 'SEED'


class AudienceReference15(BaseModel):
    audienceType: str
    kind: Kind48


class AudienceReference(
    RootModel[Union[AudienceReference13, AudienceReference14, AudienceReference15]]
):
    root: Union[AudienceReference13, AudienceReference14, AudienceReference15]


class BooleanOp(Enum):
    AND = 'AND'
    OR = 'OR'


class CombineOperator(Enum):
    INTERSECT = 'INTERSECT'
    UNION = 'UNION'
    DIFF = 'DIFF'


class Kind49(Enum):
    LOOKALIKE = 'LOOKALIKE'


class CustomAudienceDefinition9(BaseModel):
    excludeSeedAudience: Optional[bool] = None
    kind: Kind49
    reach: conint(ge=0)
    sourceRef: AudienceReference


class Kind50(Enum):
    RULE_BASED = 'RULE_BASED'


class FilterOperator(Enum):
    CONTAINS_ANY_OF = 'CONTAINS_ANY_OF'
    CONTAINS_NONE_OF = 'CONTAINS_NONE_OF'
    CONTAINS_ALL_OF = 'CONTAINS_ALL_OF'
    EMPTY = 'EMPTY'
    NOT_EMPTY = 'NOT_EMPTY'


class StalenessWarnings(BaseModel):
    missingCustomAudiences: Optional[Sequence[str]] = []
    missingFilterAttributes: Optional[Sequence[str]] = []
    missingFilterValues: Optional[Sequence[str]] = []
    missingSeedAudiences: Optional[Sequence[str]] = []


class AudienceFilter(BaseModel):
    attribute: str
    operator: FilterOperator
    values: Optional[Sequence[str]] = None


class AudienceFilters(BaseModel):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class AudienceCombinator(BaseModel):
    filters: Optional[AudienceFilters] = None
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition10(BaseModel):
    combine: Optional[Sequence[AudienceCombinator]] = None
    filters: Optional[AudienceFilters] = None
    kind: Kind50
    sourceRef: AudienceReference


class CustomAudienceDefinition(
    RootModel[Union[CustomAudienceDefinition9, CustomAudienceDefinition10]]
):
    root: Union[CustomAudienceDefinition9, CustomAudienceDefinition10]


class CustomAudienceView(BaseModel):
    createdAt: str
    createdBy: str
    definition: CustomAudienceDefinition
    doesAudienceDependOnLookalikeAudience: Optional[bool] = False
    id: str
    name: str
    sharedWith: Optional[Sequence[str]] = []
    stalenessWarnings: Optional[StalenessWarnings] = None


class CreateCustomAudience(BaseModel):
    audience: CustomAudienceView


class DataRoomActionResponse8(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    createCustomAudience: CreateCustomAudience


class CustomAudience(BaseModel):
    createdAt: str
    createdBy: str
    definition: CustomAudienceDefinition
    id: str
    name: str
    sharedWith: Optional[Sequence[str]] = []


class DeleteCustomAudiences(BaseModel):
    conflictingAudiences: Sequence[CustomAudience]


class DataRoomActionResponse5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deleteCustomAudiences: DeleteCustomAudiences


class GetAudiencePrerequisites(BaseModel):
    audiences: Sequence[CustomAudience]


class DataRoomActionResponse7(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getAudiencePrerequisites: GetAudiencePrerequisites


class UpdateCustomAudience(BaseModel):
    audience: Optional[CustomAudience] = None


class DataRoomActionResponse9(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    updateCustomAudience: UpdateCustomAudience


class DataRoomActionResponse(
    RootModel[
        Union[
            DataRoomActionResponse1,
            DataRoomActionResponse2,
            DataRoomActionResponse3,
            DataRoomActionResponse4,
            DataRoomActionResponse5,
            DataRoomActionResponse6,
            DataRoomActionResponse7,
            DataRoomActionResponse8,
            DataRoomActionResponse9,
        ]
    ]
):
    root: Union[
        DataRoomActionResponse1,
        DataRoomActionResponse2,
        DataRoomActionResponse3,
        DataRoomActionResponse4,
        DataRoomActionResponse5,
        DataRoomActionResponse6,
        DataRoomActionResponse7,
        DataRoomActionResponse8,
        DataRoomActionResponse9,
    ] = Field(..., title='DataRoomActionResponse')
